`include "mips.h"

module forwarding(rfValue,rfAddr,wb0Value,wb0Addr,wb1Value,wb1Addr,wb2Value,wb2Addr,wb3Value,wb3Addr,outValue);
input [5:0] rfAddr,wb0Addr,wb1Addr,wb2Addr,wb3Addr;
input [31:0] rfValue,wb0Value,wb1Value,wb2Value,wb3Value;
output reg [31:0] outValue;

always @(*)begin
	if(rfAddr == 0)begin
		outValue = 0;
	end
	else begin
		if(rfAddr == wb0Addr)begin
			outValue = wb0Value;	
		end
		else if(rfAddr == wb1Addr)begin
			outValue = wb1Value;
		end
		else if(rfAddr == wb2Addr)begin
			outValue = wb2Value;
		end
		else if(rfAddr == wb3Addr)begin
			outValue = wb3Value;
		end
		else begin
			outValue = rfValue;
		end
	end
end

endmodule